#version 120

#define RESET 0 // [0 1]

#define COLOR_ORDER 0 //Color orders. 0 = RGB DEFAULT. 1 = RBG. 2 = BGR. 3 = GRB [0 1 2 3]

// COLOR EQUATIONS
#define R_TYPE 0 //Equation type. 0 = R+a. 1 = R-a. 2 = R*a. 3 = R/a. 4 = R=a. 5 = 1-R (Invert) [0 1 2 3 4 5]
#define R_A 0 //a. 0-4 [0 0.5 1.0 1.5 2.0 2.5 3.0 3.5 4.0 var_a var_b]

#define G_TYPE 0 //Equation type. 0 = G+a. 1 = G-a. 2 = G*a. 3 = G/a. 4 = G=a. 5 = 1-G (Invert) [0 1 2 3 4 5]
#define G_A 0 //a. 0-4 [0 0.5 1.0 1.5 2.0 2.5 3.0 3.5 4.0 var_a var_b]

#define B_TYPE 0 //Equation type. 0 = B+a. 1 = B-a. 2 = B*a. 3 = B/a. 4 = B=a. 5 = 1-B (Invert) [0 1 2 3 4 5]
#define B_A 0 //a. 0-4 [0 0.5 1.0 1.5 2.0 2.5 3.0 3.5 4.0 var_a var_b]

#define RGB_TYPE 0 //Equation type. 0 = RGB+a. 1 = RGB-a. 2 = RGB*a. 3 = RGB/a. 4 = RGB=a. 5 = 1-RGB (Invert) [0 1 2 3 4 5]
#define RGB_A 0 //a. 0-4 [0 0.5 1.0 1.5 2.0 2.5 3.0 3.5 4.0 var_a var_b]

// VARIABLES
#define V_A_VALUE_1 0 //Variable A's ones place. 0-9 [0 1 2 3 4 5 6 7 8 9]
#define V_A_VALUE_10 0.0 //Variable A's tenths place. 0-9 [0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9]
#define V_A_VALUE_100 0.00 //Variable A's hundredths place. 0-9 [0.00 0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09]
#define V_A_POS //Is variable A positive?

#define V_B_VALUE_1 0 //Variable B's ones place. 0-9 [0 1 2 3 4 5 6 7 8 9]
#define V_B_VALUE_10 0.0 //Variable B's tenths place. 0-9 [0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9]
#define V_B_VALUE_100 0.00 //Variable B's hundredths place. 0-9 [0.00 0.01 0.02 0.03 0.04 0.05 0.06 0.07 0.08 0.09]
#define V_B_POS //Is variable B positive?


#define ENABLE_VIGNETTE // Enable Vignette
#define VIGNETTE_STRENGTH 2.5 //When this number goes down the strength goes up. [0.1 0.5 1.0 2.0 2.5]

varying vec4 texcoord;

uniform sampler2D gcolor;

void Vignette(inout vec3 color) {

    #ifdef ENABLE_VIGNETTE
    float dist = distance(texcoord.st, vec2(0.5)) * 2.0;
    dist /= VIGNETTE_STRENGTH;
    dist = pow(dist, 1.0f);
    color.rgb *= 1.0f - dist;
    #endif
}

void main() {

    #ifdef V_A_POS
    float var_a = V_A_VALUE_1 + V_A_VALUE_10 + V_A_VALUE_100;
    #else
    float var_a = 0 - (V_A_VALUE_1 + V_A_VALUE_10 + V_A_VALUE_100);
    #endif

    #ifdef V_B_POS
    float var_b = V_B_VALUE_1 + V_B_VALUE_10 + V_B_VALUE_100;
    #else
    float var_b = 0 - (V_B_VALUE_1 + V_B_VALUE_10 + V_B_VALUE_100);
    #endif

    vec3 color = texture2D(gcolor, texcoord.st).rgb;
    
    //Color Equations
    //R
    #if (R_TYPE == 0)
    color.r = color.r + R_A;
    #endif
    #if (R_TYPE == 1)
    color.r = color.r - R_A;
    #endif
    #if (R_TYPE == 2)
    color.r = color.r * R_A;
    #endif
    #if (R_TYPE == 3)
    color.r = color.r / R_A;
    #endif
    #if (R_TYPE == 4)
    color.r = R_A;
    #endif
    #if (R_TYPE == 5)
    color.r = 1 - color.r;
    #endif
    //G
    #if (G_TYPE == 0)
    color.g = color.g + G_A;
    #endif
    #if (G_TYPE == 1)
    color.g = color.g - G_A;
    #endif
    #if (G_TYPE == 2)
    color.g = color.g * G_A;
    #endif
    #if (G_TYPE == 3)
    color.g = color.g / G_A;
    #endif
    #if (G_TYPE == 4)
    color.g = G_A;
    #endif
    #if (G_TYPE == 5)
    color.g = 1 - color.g;
    #endif
    //B
    #if (B_TYPE == 0)
    color.b = color.b + B_A;
    #endif
    #if (B_TYPE == 1)
    color.b = color.b - B_A;
    #endif
    #if (B_TYPE == 2)
    color.b = color.b * B_A;
    #endif
    #if (B_TYPE == 3)
    color.b = color.b / B_A;
    #endif
    #if (B_TYPE == 4)
    color.b = B_A;
    #endif
    #if (B_TYPE == 5)
    color.b = 1 - color.b;
    #endif
    //RGB
    #if (RGB_TYPE == 0)
    color.rgb = color.rgb + RGB_A;
    #endif
    #if (RGB_TYPE == 1)
    color.rgb = color.rgb - RGB_A;
    #endif
    #if (RGB_TYPE == 2)
    color.rgb = color.rgb * RGB_A;
    #endif
    #if (RGB_TYPE == 3)
    color.rgb = color.rgb / RGB_A;
    #endif
    #if (RGB_TYPE == 4)
    color.rgb = RGB_A;
    #endif
    #if (RGB_TYPE == 5)
    color.rgb = 1 - color.rgb;
    #endif

    Vignette(color);

    //Color Order
    #if (COLOR_ORDER == 0)
    gl_FragColor = vec4(color.rgb, 1.0f);
    #endif

    #if (COLOR_ORDER == 1)
    gl_FragColor = vec4(color.rbg, 1.0f);
    #endif

    #if (COLOR_ORDER == 2)
    gl_FragColor = vec4(color.bgr, 1.0f);
    #endif

    #if (COLOR_ORDER == 3)
    gl_FragColor = vec4(color.grb, 1.0f);
    #endif

}